#include <iostream>
#include <map>
#include <vector>

#define MAX_K 200001
#define NO_PARENT -1

std::vector<std::vector<int>> gm;

int d[MAX_K];
bool used[MAX_K];
int pred[MAX_K];

int main()
{
    int n;
    std::cin >> n;

    n++;

    gm.resize(n);
    for(int i = 0; i < n; i++)
    {
        gm[i].resize(n);
        std::fill(gm[i].begin(), gm[i].end(), -1);
    }


    int p, q;
    for(int i = 2; i < n; i++)
    {
        std::cin >> p >> q;

        gm[p][q] = 0;
        gm[q][p] = 0;
    }

    int m;
    std::cin >> m;

    int g, k;
    for(int i = 0; i < m; i++)
    {
        std::cin >> g >> k;

        for(int i = 1; i < n; i++)
            if(gm[i][g] != -1)
                gm[i][g] = k;
    }

    int t;
    std::cin >> t;

    int a;
    while(t--)
    {
        std::cin >> a;

        for(int i = 1; i < n; i++)
            for(int j = 1; j < n; j++)
                if(gm[i][j] == -1)
                    gm[i][j] = MAX_K;

        for(int i = 1; i < n; i++)
        {
            used[i] = true;
            pred[i] = NO_PARENT;

            d[i] = gm[a][i];
            if(d[i] < MAX_K)
                pred[i] = a;
        }

        used[a] = false;
        pred[a] = NO_PARENT;

        while(true)
        {
            int j = NO_PARENT;
            int ds = MAX_K;

            for(int i = 1; i < n; i++)
            {
                if(used[i] && d[i] < ds)
                {
                    ds = d[i];
                    j = i;
                }
            }

            if(j == NO_PARENT)
                break;

            used[j] = false;

            for(int i = 1; i < n; i++)
                if(d[i] > d[j] + gm[j][i])
                {
                    d[i] = d[j] + gm[j][i];
                    pred[i] = j;
                }
        }

        int max_d = -1;
        for(int i = 1; i < n; i++)
            if(d[i] > max_d)
                max_d = d[i];

        std::cout << max_d << " ";
    }

    std::cout << std::endl;

    return 0;
}
