#include <iostream>
#include <regex>
#include <string>
#include <queue>

std::regex r_xoh(".*?X.*?O.*?H.*?", std::regex_constants::optimize);
std::regex rb_xoh(".*?H.*?O.*?X.*?", std::regex_constants::optimize);

char allowed[] = {'O', 'H', 'X'};

bool contains_XOH(const std::string &s)
{
    return std::regex_match(s, r_xoh) ||
           std::regex_match(s, rb_xoh);
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    long long n;
    int m;
    std::cin >> n >> m;

    std::queue<std::string> q;
    std::string first;
    first.reserve(n);

    q.push(first);

    int sol = 0;
    while(!q.empty())
    {
        std::string curr = q.front();
        q.pop();

        if(contains_XOH(curr))
            continue;

        int cs = curr.size();
        if(cs < n) {
            curr.append(" ");

            for(int i = 0; i < 3; i++)
            {
                curr[cs] = allowed[i];
                q.push(curr);
            }
        }
        else
            sol = (sol + 1) % m;
    }

    std::cout << sol << std::endl;

    return 0;
}
