#include <iostream>
#include <regex>
#include <string>
#include <set>

std::regex r_xoh(".*?X.*?O.*?H.*?");
std::regex rb_xoh(".*?H.*?O.*?X.*?");

char allowed[] = {'X', 'O', 'H'};

bool is_xoh(const std::string& s)
{
    return std::regex_match(s, r_xoh) || std::regex_match(s, rb_xoh);
}

int generate_xoh(int n, int m, std::string c, int k)
{
    if(k == 0)
        return !is_xoh(c);

    int sol = 0;

    for(int i = 0; i < 3; i++)
        sol += generate_xoh(n, m, c + allowed[i], k-1);

    return sol % m;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    std::cout << generate_xoh(n, m, "", n) << std::endl;

    return 0;
}
