#include <bits/stdc++.h>

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 200001;
const int TREE_SIZE = 1048576;

int n;
vector<int> g[MAXN];
int k[MAXN];
long long dp[MAXN];

long long bfs(int start) {
    long long ans = 0;
    memset(dp, 0, sizeof(dp));
    dp[start] = k[start];
    queue<pair<int, int>> q;
    q.emplace(start, -1);
    while (!q.empty()) {
        pair<int, int> now = q.front();
        q.pop();
        for (int adj : g[now.first]) {
            if (adj != now.second) {
                dp[adj] = dp[now.first] + k[adj];
                q.emplace(adj, now.first);
            }
        }
    }
    for (int i = 1; i <= n; i++) chkmax(ans, dp[i]);
    return ans;
}

int euler[MAXN << 1];
int depth[MAXN << 1];
int first[MAXN];
int euler_ptr = 0;

void dfs(int node, int parent, int lvl) {
    euler[euler_ptr] = node;
    depth[euler_ptr] = lvl;
    if (first[node] == -1) first[node] = euler_ptr;
    euler_ptr++;
    for (int adj : g[node]) {
        if (adj != parent) {
            dfs(adj, node, lvl + 1);
            euler[euler_ptr] = node;
            depth[euler_ptr] = lvl;
            euler_ptr++;
        }
    }
}

int tree[TREE_SIZE];

void build(int idx, int low, int high) {
    if (low == high) {
        tree[idx] = low;
        return;
    }
    int mid = (low + high) >> 1;
    build(idx << 1, low, mid);
    build(idx << 1 | 1, mid + 1, high);
    tree[idx] = depth[tree[idx << 1]] < depth[tree[idx << 1 | 1]] ? tree[idx << 1] : tree[idx << 1 | 1];
}

int query(int idx, int low, int high, int left, int right) {
    if (low >= left && high <= right) return tree[idx];
    if (high < left || low > right) return -1;
    int mid = (low + high) >> 1;
    int p1 = query(idx << 1, low, mid, left, right);
    int p2 = query(idx << 1 | 1, mid + 1, high, left, right);
    if (p1 == -1) return p2;
    if (p2 == -1) return p1;
    return depth[p1] < depth[p2] ? p1 : p2;
}

int lca(int u, int v) {
    u = first[u];
    v = first[v];
    if (u > v) swap(u, v);
    return euler[query(1, 0, euler_ptr - 1, u, v)];
}

int get_sum(int u, int v) {
    int mid = lca(u, v);
    return dp[u] - dp[mid] + dp[v] - dp[mid] + k[mid] - k[u];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].emplace_back(v);
        g[v].emplace_back(u);
    }
    memset(k, 0, sizeof(k));
    int m;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        int node, k;
        cin >> node >> k;
        ::k[node] = k;
    }
    bfs(1);
    memset(first, -1, sizeof(first));
    dfs(1, -1, 1);
    build(1, 0, euler_ptr - 1);
    int t;
    cin >> t;
    for (int i = 1; i <= t; i++) {
        int s;
        cin >> s;
        int ans = 0;
        for (int j = 1; j <= n; j++) {
            if (j == s) continue;
            chkmax(ans, get_sum(s, j));
        }
        cout << ans << " \n"[i == t];
    }

    return EXIT_SUCCESS;
}


/**
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8
*/
