#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

int parent [200000];
vector <int> ln [200000];
int g [200000];
bool visited [200000];
int cost [200000];
vector<int> leaves_of [200000];

template<typename Iterable>
void leaves (int n, Iterable& container)
{
	for (int i = 0 ; i < n ; i ++)
	{
		if (ln [i].size () == 1) // leaf
		{
			container.push_back(i);
		}
	}
}

int pre (const int&, const int&, int, int);//, int);
template <typename Iterable>
int calc (const int&, const int&, int, Iterable&);

int main () 
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	for (int i = 0 ; i < n - 1 ; i ++)
	{
		int a, b;
		cin >> a >> b;
		a --; b --;
		ln [a].push_back(b);
		ln [b].push_back(a);
		parent [i] = parent [i + 1] = -1;
	}
	vector <int> end_points;
	leaves (n, end_points);
	int root = end_points [0];

	int m;
	cin >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		int a, k;
		cin >> a >> k; 
		a --;
		g [a] = k;
	}
	
	pre(n, root, -1, 0);//, 0);

	int t;
	cin >> t;
	while (t --) 
	{
		int a;
		cin >> a;
		a --;
		cout << calc (n, root, a, end_points) << " ";
	}
}

int pre (const int& n, const int& root, int v, int c)//, int level)
{
	if (v == -1)
		v = root, c = 0, visited [root] = true;

	cost [v] = c + g [v];

	//for (int i = 0 ; i < level ; i ++)
	//	cout << '\t';
	//cout << v + 1 << '(' << cost [v] << ')' << '\n';
	
	int leaf = v;

	for (int i : ln [v])
		if (not visited [i])
		{
			visited [i] = true;
			parent [i] = v;
			leaf = pre (n, root, i, cost [v]);//, level + 1);
			visited [i] = false;
		}
	if (leaf == v)
		for (int i = 0 ; i < n ; i ++)
			if (visited [i])
				leaves_of [i].push_back (leaf);
	return leaf;
}

template <typename Iterable>
int calc (const int& n, const int& root, int v, Iterable& leaves)
{
	set < int > not_leaves_of_v (begin(leaves), end(leaves));
	int ans = 0;
	ans = max (ans, cost [v] - g [v]); // to root
	//cout << "calc " << v + 1 << ": ";
	//cout << "max of " << cost [v] - g [v] << "(root)";
	for (auto& x : leaves_of [v])
	{
		not_leaves_of_v.erase (not_leaves_of_v.find (x));
		//cout << ", " << cost [x] - cost [v] << "(leaf " << x + 1 << ", vertex " << v + 1 << ")";
		ans = max (ans, cost [x] - cost [v]); // v to leaf of subtree v
	}
	set < int > parents;
	int a = v;
	while (a != -1)
	{
		parents.insert (a);
		a = parent [a];
	}
	int lca = root;
	for (auto& x : not_leaves_of_v)
	{
		lca = root;
		a = x; 
		while (a != -1)
		{
			if (parents.find (a) != parents.end())
			{
				lca = a;
				break;
			}
			a = parent [a];
		}
		ans = max (ans, cost [v] - g [v] + cost [x] - 2 * cost [lca] + g [lca]);
	}
	//cout << '\n';
	return ans;
}
