#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

int parent [200000];
vector <int> ln [200000];
int g [200000];
bool visited [200000];
int cost [200000];
int optimal_leaf_cost [200000];
int level [200000];
vector < vector < int > > lca;

template<typename Iterable>
void leaves (int n, Iterable& container)
{
	for (int i = 0 ; i < n ; i ++)
	{
		if (ln [i].size () == 1) // leaf
		{
			container.push_back(i);
		}
	}
}

int pre (const int&, const int&, int, int);
int calc (const int&, const int&, int);

int main () 
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	for (int i = 0 ; i < n - 1 ; i ++)
	{
		int a, b;
		cin >> a >> b;
		a --; b --;
		ln [a].push_back(b);
		ln [b].push_back(a);
		parent [i] = parent [i + 1] = -1;
	}
	vector <int> end_points;
	leaves (n, end_points);
	int root = end_points.back();
	end_points.pop_back();

	int m;
	cin >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		int a, k;
		cin >> a >> k; 
		a --;
		g [a] = k;
	}
	
	pre(n, root, -1, 0);
	
	vector <pair < int, int > > end_points_level (end_points.size (), {0, 0});
	lca.resize (end_points.size (), vector <int> (end_points.size (), root));
	for (int i = 0 ; i < end_points.size () ; i ++)
	{
		end_points_level [i] = { level [end_points [i]], end_points [i] };
	}
	for (int i = 0 ; i < end_points_level.size () ; i ++)
		for (int j = i + 1 ; j < end_points_level.size () ; j ++)
		{
			auto a = end_points_level [i], b = end_points_level [j];
			while (a.first > b.first)
				a = {a.first - 1, parent [a.second]};
			while (a.first < b.first)
				b = {b.first - 1, parent [b.second]};
			while (a.second != b.second and a.first >= 0)
			{
				a = {a.first - 1, parent [a.second]};
				b = {b.first - 1, parent [b.second]};
			}
			lca [j][i] = lca [i][j] = a.second;
		}
	int t;
	cin >> t;
	while (t --) 
	{
		int a;
		cin >> a;
		a --;
		cout << calc (n, root, a) << " ";
	}
}

int pre (const int& n, const int& root, int v, int c)
{
	if (v == -1)
		v = root, c = 0, visited [root] = true, level [v] = 0;

	cost [v] = c + g [v];
	
	int leaf = v;

	for (int i : ln [v])
		if (not visited [i])
		{
			visited [i] = true;
			parent [i] = v;
			level [i] = level [v] + 1;
			int curr_leaf = pre (n, root, i, cost [v]);
			if (cost [curr_leaf] > cost [leaf])
				leaf = curr_leaf;
			visited [i] = false;
		}
	optimal_leaf_cost [v] = max (optimal_leaf_cost [v], cost [leaf] - cost [v]); // v to leaf of subtree v
	return leaf;
}

int calc (const int& n, const int& root, int v)
{
	int ans = 0;
	ans = max (ans, cost [v] - g [v]); // to root
	ans = max (ans, optimal_leaf_cost [v]); // v to leaf of subtree v
	/*
	set < int > parents;
	int a = v;
	while (a != -1)
	{
		parents.insert (a);
		a = parent [a];
	}
	int lca = root;
	for (auto& x : not_leaves_of_v)
	{
		lca = root;
		a = x; 
		while (a != -1)
		{
			if (parents.find (a) != parents.end())
			{
				lca = a;
				break;
			}
			a = parent [a];
		}
		ans = max (ans, cost [v] - g [v] + cost [x] - 2 * cost [lca] + g [lca]);
	}
	//cout << '\n';*/
	return ans;
}
