#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

vector <int> ln [200000];
int g [200000];

struct tree {
	int n;
	bool* visited;
	int* cost;
	int* _cost;
	int* optimal_leaf_cost;
	int root;
	
	~tree () {
		delete[] visited;
		delete[] cost;
		delete[] _cost;
		delete[] optimal_leaf_cost;
	}
	
	tree (const int& n, int root) {
		//cout << n << " " << root << endl; cout.flush();
		this->root = root;
		//cout << n << " " << root << endl; cout.flush();
		this->n = n;
		//cout << n << " " << root << endl; cout.flush();
		visited = new bool [n];
		//cout << n << " " << root << endl; cout.flush();
		cost = new int [n];
		_cost = new int [n];
		//cout << n << " " << root << endl; cout.flush();
		optimal_leaf_cost = new int [n];
		//cout << n << " " << root << endl; cout.flush();
	}

	int pre (int, int);
	void finalize () {
		for (int i = 0 ; i < n ; i ++)
			_cost [i] = max (_cost [i], cost [i]);
	}
};

template<typename Iterable>
void leaves (int n, Iterable& container)
{
	for (int i = 0 ; i < n ; i ++)
	{
		if (ln [i].size () == 1) // leaf
		{
			container.push_back(i);
		}
	}
}
int calc (const vector<tree*>&, const int&);

int main () 
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	for (int i = 0 ; i < n - 1 ; i ++)
	{
		int a, b;
		cin >> a >> b;
		a --; b --;
		ln [a].push_back(b);
		ln [b].push_back(a);
	}
	vector <int> end_points;
	leaves (n, end_points);

	int m;
	cin >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		int a, k;
		cin >> a >> k; 
		a --;
		g [a] = k;
	}
	
	vector <tree*> trees;
	trees.reserve (end_points.size ());
		trees.push_back (new tree (n, 0));
	for (auto& root : end_points)
	{
		trees [trees.size () - 1]->root = root;
			//cout << "tree " << trees.size () + 1 << " root " << root << endl; cout.flush ();
			//cout << "tree " << trees.size () + 1 << " root " << root << endl; cout.flush ();
		trees [trees.size()-1]->pre(-1, 0);
		trees [trees.size()-1]->finalize();
		//cout << "tree " << trees.size () << " completed" << endl; cout.flush ();
	}
	
	int t;
	cin >> t;
	while (t --) 
	{
		int a;
		cin >> a;
		a --;
		cout << calc (trees, a) << " ";
	}
}

int tree::pre (int v, int c)
{
	if (v == -1)
		v = root, c = 0, visited [root] = true;

	cost [v] = c + g [v];
	//cout << v + 1 << " " << c << endl; cout.flush ();
	
	int leaf = v;

	for (int i : ln [v])
		if (not visited [i])
		{
			visited [i] = true;
			int curr_leaf = pre (i, cost [v]);
			if (cost [curr_leaf] > cost [leaf])
				leaf = curr_leaf;
			visited [i] = false;
		}
	optimal_leaf_cost [v] = max (optimal_leaf_cost [v], cost [leaf] - cost [v]); // v to leaf of subtree v
	return leaf;
}

int calc (const vector <tree*>& trees, const int& v)
{
	int ans = 0;
	for (const auto& Tree : trees)
	{
		ans = max (ans, Tree->_cost [v] - g [v]); // to root
		ans = max (ans, Tree->optimal_leaf_cost [v]); // v to leaf of subtree v
	}
	return ans;
}
