#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

vector <int> ln [200000];
int g [200000];

struct tree {
	int n;
	bool visited [200000];
	int cost [200000];
	int _cost [200000];
	int root;
	
	tree (const int& n, int root) {
		this->root = root;
		this->n = n;
	}

	int pre (int, int);
};

template<typename Iterable>
void leaves (int n, Iterable& container)
{
	for (int i = 0 ; i < n ; i ++)
	{
		if (ln [i].size () == 1 and g [i] > 0) // leaf
		{
			container.push_back(i);
		}
	}
}
int calc (const tree*, const int&);

int main () 
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	for (int i = 0 ; i < n - 1 ; i ++)
	{
		int a, b;
		cin >> a >> b;
		a --; b --;
		ln [a].push_back(b);
		ln [b].push_back(a);
	}

	int m;
	cin >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		int a, k;
		cin >> a >> k; 
		a --;
		g [a] = k;
	}
	
	vector <int> end_points;
	leaves (n, end_points);
	
	tree Tree (n, 0);
	for (auto& root : end_points)
	{
		Tree.root = root;
		Tree.pre(-1, 0);
	}
	
	int t;
	cin >> t;
	while (t --) 
	{
		int a;
		cin >> a;
		a --;
		cout << calc (&Tree, a) << " ";
	}
}

int tree::pre (int v, int c)
{
	if (v == -1)
		v = root, c = 0, visited [root] = true;

	cost [v] = c + g [v];
	
	int leaf = v;

	for (int i : ln [v])
		if (not visited [i])
		{
			visited [i] = true;
			int curr_leaf = pre (i, cost [v]);
			if (cost [curr_leaf] > cost [leaf])
				leaf = curr_leaf;
			visited [i] = false;
		}
	_cost [v] = max (_cost [v], max (cost [v] - g [v], cost [leaf] - cost [v]));
	if (v == root)
		visited [root] = false;
	return leaf;
}

inline int calc (const tree* Tree, const int& v)
{
	return Tree->_cost [v];
}
