#include <iostream>
#include <vector>
#include <queue>

using namespace std;

struct vert{
    int value = 0;
    vector<int> adj;
};

const int maxn = 200000;
vert tree[maxn];
int used[maxn];
priority_queue< pair<int, int> > frontier;
pair<int, int> answer;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;
    for(int i=0; i<n-1; i++){
        int first, second;
        cin >> first >> second;
        tree[first].adj.push_back(second);
        tree[second].adj.push_back(first);
    }

    ///cout << "tree cinned" << endl;

    int m;
    cin >> m;
    for(int i=0; i<m; i++){
        int ver, val;
        cin >> ver >> val;
        tree[ver].value = val;
    }

    ///cout << "value cinned" << endl;

    int t;
    cin >> t;
    for(int i=0; i<t; i++){
        int currTurn = i+1;
        int first;
        cin >> first;

        ///cout << "Turn: " << currTurn << endl;

        frontier.push( make_pair(0, first) );
        answer = make_pair(0, first);

        while(!frontier.empty()){
            int currVert = frontier.top().second;
            int currDist = - frontier.top().first;
            frontier.pop();

            if(used[currVert]==currTurn) continue;
            used[currVert]=currTurn;

            ///cout << "currVert: " << currVert << endl;

            answer = max(answer, make_pair(currDist, currVert));

            for(int j=0; j<tree[currVert].adj.size(); j++){
                int neiVert = tree[currVert].adj[j];
                int neiDist = tree[neiVert].value;

                if(used[neiVert]==currTurn) continue;
                ///cout << "neiVert: (NOT USED): " << neiVert << endl;
                int currTotalDist = currDist + neiDist;
                frontier.push( make_pair(-currTotalDist, neiVert) );
            }
        }

        ///cout << "Answer is: " << answer.first << endl << endl;
        cout << answer.first << " ";

    }
    cout << endl;

    return 0;
}
/*
9
3 6
3 4
6 1
1 7
4 2
4 5
2 8
2 9
5
3 3
2 1
5 2
9 4
7 3
3
3 2 8
*/

